<?php
ini_set( "display_errors", 0);

require_once 'globals.php';

##########
# This file is part of Koala.
#
# Koala is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Koala is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Koala.  If not, see <http://www.gnu.org/licenses/>.
##########

##########
# set up basic scripting variables
$datasets  = array();
$box_order = array();
##########

##########
# status variables
$fail = !empty($_GET['fail']);
$success = !empty($_GET['success']);
##########

##########
# data for form
$organism = (isset($_POST['organism']) ? $_POST['organism'] : "");
$nickname = (isset($_POST['nickname']) ? $_POST['nickname'] : "");
$type = (isset($_POST['type']) ? $_POST['type'] : "");
$experimentDate = (isset($_POST['experimentDate']) ? $_POST['experimentDate'] : date("Y-n-j", time()));
$owner = (isset($_POST['owner']) ? $_POST['owner'] : "");
$phases = (isset($_POST['phases']) ? $_POST['phases'] : "");
$summary = (isset($_POST['summary']) ? $_POST['summary'] : "");
# publication metadata variables
$title = (isset($_POST['title']) ? $_POST['title'] : "");
$accession = (isset($_POST['accession']) ? $_POST['accession'] : "");
$description = (isset($_POST['description']) ? $_POST['description'] : "");
$contributors = (isset($_POST['contributors']) ? $_POST['contributors'] : "");
$growthProtocol = (isset($_POST['growthProtocol']) ? $_POST['growthProtocol'] : "");
$treatmentProtocol = (isset($_POST['treatmentProtocol']) ? $_POST['treatmentProtocol'] : "");
$labelingProtocol = (isset($_POST['labelingProtocol']) ? $_POST['labelingProtocol'] : "");
$hybridizationProtocol = (isset($_POST['hybridizationProtocol']) ? $_POST['hybridizationProtocol'] : "");
$scanProtocol = (isset($_POST['scanProtocol']) ? $_POST['scanProtocol'] : "");
$dataProtocol = (isset($_POST['dataProtocol']) ? $_POST['dataProtocol'] : "");
$otherProtocol = (isset($_POST['otherProtocol']) ? $_POST['otherProtocol'] : "");
$manufacturer = (isset($_POST['manufacturer']) ? $_POST['manufacturer'] : "");
$manufactureProtocol = (isset($_POST['manufactureProtocol']) ? $_POST['manufactureProtocol'] : "");
$channelCount = (isset($_POST['channelCount']) ? $_POST['channelCount'] : "");
$instrumentModel = (isset($_POST['instrumentModel']) ? $_POST['instrumentModel'] : "");
$machineCharacteristics = (isset($_POST['machineCharacteristics']) ? $_POST['machineCharacteristics'] : "");
##########

##########
# handle any modifications (such as inserting new datasets, etc.
# key - the database primary key - if we are editing or deleting datasets
#       this is zero (0) if we are adding new data
if (!empty($_POST['key'])) {
	$key = (int) $_POST['key'];
} elseif (!empty($_GET['key'])) {
	$key = (int) $_GET['key'];
}
# connect to the database
$link = mysql_pconnect(DB_URL, DB_USER, DB_PW) or die ("Unable to connect to database");
mysql_select_db(DB_NAME, $link) or die("Unable to select database");

# handle the logmode and absolute values checkboxes
$logmode = (!empty($_POST['logmode']) ? "1" : "0");
$absolute = (!empty($_POST['absolute']) ? "1" : "0");

# Handle new entries
if (!empty($_POST['add'])) {
	# ensure that the new entry is formatted properly
	if (!empty($_FILES['expressionData']) && ($handle = fopen($_FILES['expressionData']['tmp_name'], "r")) !== FALSE && !empty($nickname) && !empty($organism)) {
		# perform the insertion
		mysql_query("INSERT INTO koaladatasets (organism, nickname, type, experimentDate, owner, phases, summary, logmode, absolute, title, accession, description, contributors, growthProtocol, treatmentProtocol, labelingProtocol, hybridizationProtocol, scanProtocol, dataProtocol, otherProtocol, manufacturer, manufactureProtocol, channelCount, instrumentModel, machineCharacteristics) VALUES (\"" .
			mysql_real_escape_string($organism, $link) . "\", \"" .
			mysql_real_escape_string($nickname, $link) . "\", \"" .
			mysql_real_escape_string($type, $link) . "\", \"" .
			mysql_real_escape_string($experimentDate, $link) . "\", \"" .
			mysql_real_escape_string($owner, $link) . "\", \"" .
			mysql_real_escape_string($phases, $link) . "\", \"" .
			mysql_real_escape_string($summary, $link) . "\", " .
			$logmode . ", " . $absolute . ", \"" .
			mysql_real_escape_string($title, $link) . "\", \"" .
			mysql_real_escape_string($accession, $link) . "\", \"" . 
			mysql_real_escape_string($description, $link) . "\", \"" .
			mysql_real_escape_string($contributors, $link) . "\", \"" . 
			mysql_real_escape_string($growthProtocol, $link) . "\", \"" . 
			mysql_real_escape_string($treatmentProtocol, $link) . "\", \"" .
			mysql_real_escape_string($labelingProtocol, $link) . "\", \"" .
			mysql_real_escape_string($hybridizationProtocol, $link) . "\", \"" .
			mysql_real_escape_string($scanProtocol, $link) . "\", \"" . 
			mysql_real_escape_string($dataProtocol, $link) . "\", \"" . 
			mysql_real_escape_string($otherProtocol, $link) . "\", \"" . 
			mysql_real_escape_string($manufacturer, $link) . "\", \"" . 
			mysql_real_escape_string($manufactureProtocol, $link) . "\", \"" . 
			mysql_real_escape_string($channelCount, $link) . "\", \"" . 
			mysql_real_escape_string($instrumentModel, $link) . "\", \"" . 
			mysql_real_escape_string($machineCharacteristics, $link) . "\");\n", $link);
		$row = mysql_fetch_assoc(mysql_query("SELECT id "
					. "FROM koaladatasets WHERE organism = \""
						. mysql_real_escape_string($organism, $link)
					. "\" and nickname = \""
						. mysql_real_escape_string($nickname, $link)
					. "\" and type = \""
						. mysql_real_escape_string($type, $link)
					. "\"", $link));
		$key = $row['id'];

		# insert the actual expression data into the database
		# NOTE: A nested Field object holds the file
		while (($data = fgetcsv($handle, 0, "	")) !== FALSE) {
			if (count($data) > 1) {
				$tag = mysql_real_escape_string($data[0], $link);
				$elevel = mysql_real_escape_string($data[1], $link);
				mysql_query("INSERT INTO koaladata (dataset, tag, value) VALUES (" . $key . ", \"" . $tag . "\"," . $elevel . ");\n", $link);
			}
		}
		header( 'Location: edit.php?success=true' ) ;
	} else {
		$fail = true;
	}
} elseif (!empty($_POST['edit']) and !empty($key)) {
	# ensure that the new entry is formatted properly
	if (!empty($nickname) && !empty($organism)) {
		# perform the update
		mysql_query("UPDATE koaladatasets SET organism = \"" . mysql_real_escape_string($organism, $link)
			. "\", nickname = \"" . mysql_real_escape_string($nickname, $link)
			. "\", type = \"" . mysql_real_escape_string($type, $link)
			. "\", experimentDate = \"" . mysql_real_escape_string($experimentDate, $link)
			. "\", owner = \"" . mysql_real_escape_string($owner, $link)
			. "\", phases = \"" . mysql_real_escape_string($phases, $link)
			. "\", summary = \"" . mysql_real_escape_string($summary, $link)
			. "\", logmode = \"" . $logmode
			. "\", absolute = \"" . $absolute
			. "\", title = \"" . mysql_real_escape_string($title, $link)
			. "\", accession = \"" . mysql_real_escape_string($accession, $link)
			. "\", description = \"" . mysql_real_escape_string($description, $link)
			. "\", contributors = \"" . mysql_real_escape_string($contributors, $link)
			. "\", growthProtocol = \"" . mysql_real_escape_string($growthProtocol, $link)
			. "\", treatmentProtocol = \"" . mysql_real_escape_string($treatmentProtocol, $link)
			. "\", labelingProtocol = \"" . mysql_real_escape_string($labelingProtocol, $link)
			. "\", hybridizationProtocol = \"" . mysql_real_escape_string($hybridizationProtocol, $link)
			. "\", scanProtocol = \"" . mysql_real_escape_string($scanProtocol, $link)
			. "\", dataProtocol = \"" . mysql_real_escape_string($dataProtocol, $link)
			. "\", otherProtocol = \"" . mysql_real_escape_string($otherProtocol, $link)
			. "\", manufacturer = \"" . mysql_real_escape_string($manufacturer, $link)
			. "\", manufactureProtocol = \"" . mysql_real_escape_string($manufactureProtocol, $link)
			. "\", channelCount = \"" . mysql_real_escape_string($channelCount, $link)
			. "\", instrumentModel = \"" . mysql_real_escape_string($instrumentModel, $link)
			. "\", machineCharacteristics = \"" . mysql_real_escape_string($machineCharacteristics, $link)
			. "\" WHERE id = " . $key . ";\n", $link);
		header( 'Location: edit.php?success=true&key=' . $key);
	} else {
		header( 'Location: edit.php?fail=true&key=' . $key);
	}
} elseif (!empty($_POST['delete']) and !empty($key)) {
	# delete entries from the database
	mysql_query("DELETE FROM koaladatasets WHERE id = " . $key . ";", $link);
	header( 'Location: edit.php?success=true' ) ;
}

# populate the dropdown of current datasets in Koala
# this utilizes a dictionary called 'datasets'
# execute the query - gather all of the dataset information from the database
$query = mysql_query("SELECT DATE_FORMAT(experimentDate, '%Y-%m-%d') AS eDate, koaladatasets.* FROM koaladatasets ORDER BY organism, nickname", $link);

# loop through all of the query results
while ($row = mysql_fetch_assoc($query)) {
	# add another entry to the dropdown dictionary
	$datasets[$row['id']] = $row['organism'] . " - " . $row['nickname'] . " - " . $row['type'];
	# add the current id to the box_order list
	# the box_order list is used to maintain the order
	# of the MySQL query (organism, experiment) when 
	# writing the dropdown menu to HTML
	$box_order[] = $row['id'];
	# the code below is for the edit function ONLY!
	# if the key of the currently selected database is the same
	# as the current row's primary key, then get all of the information
	# from the current row, and populate the edit boxes
	if (!empty($key) && $key == $row['id']) {
		$organism = $row["organism"];
		$nickname = $row["nickname"];
		$type = $row["type"];
		$experimentDate = $row["eDate"];
		$owner = $row["owner"];
		$phases = $row["phases"];
		$summary = $row["summary"];
		$logmode = ($row["logmode"] != 0);
		$absolute = ($row["absolute"] != 0);
		$title = $row["title"];
		$accession = $row["accession"];
		$description = $row["description"];
		$contributors = $row["contributors"];
		$growthProtocol = $row["growthProtocol"];
		$treatmentProtocol = $row["treatmentProtocol"];
		$labelingProtocol = $row["labelingProtocol"];
		$hybridizationProtocol = $row["hybridizationProtocol"];
		$scanProtocol = $row["scanProtocol"];
		$dataProtocol = $row["dataProtocol"];
		$otherProtocol = $row["otherProtocol"];
		$manufacturer = $row["manufacturer"];
		$manufactureProtocol = $row["manufactureProtocol"];
		$channelCount = $row["channelCount"];
		$instrumentModel = $row["instrumentModel"];
		$machineCharacteristics = $row["machineCharacteristics"];
	}
}
?>
<html>
	<head>
		<title>Koala back-end</title>
		<script language="javascript" type="text/javascript">
			/**
			 * Handle clicking on the edit button
			 * This function brings up the dataset selected in the dropdown
			 */
			function changeindex (index) {
				var url = document.URL;
				var urlsplit = url.split('?');
				if (urlsplit.length >= 2) {
					url = urlsplit[0];
				}
				window.location.href=url + "?key=" + index;
			}
		</script>
	</head>

	<body>
		<table>
			<tr valign="top">
				<td>
					<img src="koala.gif" align="left" />
				</td>
				<td>
					<h1>Koala back-end<small><small><small><a href="help.html" target="_blank">HELP!</a></small></small></small></h1>
<?php if ($success) { ?>
					<font color='green'>Database successfully updated!</font>
<?php } elseif ($fail) { ?>
					<font color='red'>Database could not be updated, please ensure all fields are filled out correctly!</font>
<?php } ?>
					<p>
						<form method="post" action="edit.php" enctype="multipart/form-data">
							Modify existing experiment:
							<select id="dataset_selector" name="key" onchange="changeindex(this.options[this.selectedIndex].value)">
								<option value="0">New experiment</option>
<?php
foreach ($box_order as $hkey) {
	if ($key == $hkey) { ?>
						        	<option value="<?php echo(htmlspecialchars($hkey)); ?>" selected="selected"><?php echo(htmlspecialchars($datasets[$hkey])); ?></option>
<?php } else { ?>
						        	<option value="<?php echo(htmlspecialchars($hkey)); ?>"><?php echo(htmlspecialchars($datasets[$hkey])); ?></option>
<?php } } ?>
							</select>
							<hr />
							<h3>Creating a new dataset</h3>
							<table>
								<tr>
									<td><b>Organism:</b></td>
									<td><input type="text" name="organism" value="<?php echo(htmlspecialchars($organism)); ?>" /></td>
									<td>(e.g. E-coli K-12)</td>
								</tr>
								<tr>
									<td><b>Dataset nickname:</b></td>
									<td><input type="text" name="nickname" value="<?php echo(htmlspecialchars($nickname)); ?>" /></td>
									<td>(e.g. High glucose)</td>
								</tr>
								<tr>
									<td><b>Expression data type:</b></td>
									<td><input type="text" name="type" value="<?php echo(htmlspecialchars($type)); ?>" /></td>
									<td>(e.g. proteomic Z-score)</td>
								</tr>
								<tr>
									<td><b>Date:</b></td>
									<td><input type="text" name="experimentDate" value="<?php echo(htmlspecialchars($experimentDate)); ?>" /></td>
									<td>(e.g. 2012-12-12)</td>
								</tr>
								<tr>
									<td><b>Experimentor:</b></td>
									<td><input type="text" name="owner" value="<?php echo(htmlspecialchars($owner)); ?>" /></td>
									<td>(e.g. John Smith)</td>
								</tr>
								<tr>
									<td><b>Phases:</b></td>
									<td><input type="text" name="phases" value="<?php echo(htmlspecialchars($phases)); ?>" /></td>
									<td>(e.g. exponential)</td>
								</tr>
								<tr>
									<td><b>Accession number (if available):</b></td>
									<td><input type="text" name="accession" value="<?php echo(htmlspecialchars($accession)); ?>" /></td>
									<td>(e.g. exponential)</td>
								</tr>
								<tr>
									<td><b>Short Summary with purpose of experiment (One or two sentences.):</b></td>
									<td><textarea name="summary" cols="40" rows="5"><?php echo(htmlspecialchars($summary)); ?></textarea>
								</tr>
								<tr>
									<th colspan="3">
										<hr />
										Publication metadata<br />
										<small>based on the NCBI Gene Expression Omnibus publication format criteria <a href="http://www.ncbi.nlm.nih.gov/geo/">http://www.ncbi.nlm.nih.gov/geo/</a></small>
									</th>
								</tr>
								<tr>
									<td><b>Manufacturer</b></td>
									<td><input type="text" name="manufacturer" value="<?php echo(htmlspecialchars($manufacturer)); ?>" /></td>
								</tr>
								<tr>
									<td><b>Manufacturer Protocol</b></td>
									<td><textarea name="manufactureProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($manufactureProtocol)); ?></textarea></td>
								</tr>
								<tr>
									<td><b>Channel Count</b></td>
									<td><input type="text" name="channelCount" value="<?php echo(htmlspecialchars($channelCount)); ?>" /></td>
								</tr>
								<tr>
									<td><b>Instrument model</b></td>
									<td><input type="text" name="instrumentModel" value="<?php echo(htmlspecialchars($instrumentModel)); ?>" /></td>
								</tr>
								<tr>
									<td><b>Characteristics</b></td>
									<td><input type="text" name="machineCharacteristics" value="<?php echo(htmlspecialchars($machineCharacteristics)); ?>" /></td>
								</tr>

								<tr>
									<td><b>Title of Experiment (as in publication title):</b></td>
									<td><textarea name="title" cols="40" rows="5"><?php echo(htmlspecialchars($title)); ?></textarea>
								</tr>
								<tr>
									<td><b>Full name of each contributor (This is approximately any coauthors plus the bioinfomatician and the person submitting to the "Gene expression omnibus"  website) - separated by semicolons (;):</b></td>
									<td><textarea name="contributors" cols="40" rows="5"><?php echo(htmlspecialchars($contributors)); ?></textarea>
								</tr>
								<tr>
									<td><b>Overall experimental design (as much detail as required):</b></td>
									<td><textarea name="description" cols="40" rows="5"><?php echo(htmlspecialchars($description)); ?></textarea>
								</tr>
								<tr>
									<th colspan="3">
									<br />
										Protocols: Include as many as needed (as much detail as required.) If experiments differ between samples then you must have a per/sample set of protocols. Where possible give published references, specific manufacturer details for kits, full names of software used, hardware names, models, manufacturers, readings such as optical densities.
									</th>
								</tr>
								<tr>
									<td><b>Growth protocol:</b></td>
									<td><textarea name="growthProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($growthProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Treatment protocol:</b></td>
									<td><textarea name="growthProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($growthProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Labeling protocol (i.e. Cyanine-3-labeled):</b></td>
									<td><textarea name="treatmentProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($treatmentProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Hybridization protocol:</b></td>
									<td><textarea name="hybridizationProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($hybridizationProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Scan protocol:</b></td>
									<td><textarea name="scanProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($scanProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Data processing protocol:</b></td>
									<td><textarea name="dataProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($dataProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>Other protocols:</b></td>
									<td><textarea name="otherProtocol" cols="40" rows="5"><?php echo(htmlspecialchars($otherProtocol)); ?></textarea>
								</tr>
								<tr>
									<td><b>log<sub>2</sub> scale?:</b></td>
									<td colspan="2"><input type="checkbox" name="logmode" value="1" <?php if ($logmode) { echo("checked=\"checked\""); } ?> />If this is checked, each expression value will be converted to is log<sub>2</sub> value</td>
								</tr>
								<tr>
									<td><b>Absolute (no negative values) scale:</b></td>
									<td colspan="2"><input type="checkbox" name="absolute" value="1" <?php if ($absolute) { echo("checked=\"checked\""); } ?> />If this is checked, the absolute scale will be used (when applicable) within pathway tools</td>
								</tr>
<?php if (!empty($key)) { ?>
							</table>
							<input type="hidden" name="key" value="<?php echo(htmlspecialchars($key)); ?>" />
							<input type="submit" name="edit" value="Update" />
							<input type="submit" name="delete" value="Delete" onClick="return confirm('Are you sure you wish to delete the following entry?'); " />
<?php } else { ?>
								<tr>
									<td><b>Expression Data:</b></td>
									<td><input type="file" name="expressionData" /></td>
									<td>a 2 column CSV file with the left-most (first) column containing gene identifiers (e.g. locus tags), and the second column containing gene expression data (e.g. proteomic Z-scores</td>
								</tr>
								<!--<tr>
									<td><b>Raw Data (for publication):</b></td>
									<td><input type="file" name="rawData" /></td>
									<td>The raw data you wish to use for publication</td>
								</tr>-->
							</table>
							<input type="submit" name="add" value="Add" />
<?php } ?>
						</form>
					</p>
				</td>
			</tr>
		</table>
	</body>
</html>

