DROP TABLE IF EXISTS koaladatasets;
CREATE TABLE koaladatasets (
	id BIGINT NOT NULL PRIMARY KEY AUTO_INCREMENT,
	type VARCHAR(45) NOT NULL,
	organism VARCHAR(255) NOT NULL,
	nickname VARCHAR(255) NOT NULL,
	title VARCHAR(255),
	experimentDate DATETIME NOT NULL,
	owner VARCHAR(255),
	phases VARCHAR(255),
	contributors TEXT,
	accession VARCHAR(255),
	summary TEXT,
	description LONGBLOB,
	logmode BOOLEAN NOT NULL DEFAULT FALSE,
	absolute BOOLEAN NOT NULL DEFAULT FALSE, # add this, too!
	growthProtocol LONGBLOB,
	treatmentProtocol LONGBLOB,
	labelingProtocol LONGBLOB,
	hybridizationProtocol LONGBLOB,
	scanProtocol LONGBLOB,
	dataProtocol LONGBLOB,
	otherProtocol LONGBLOB,
	manufacturer VARCHAR(255),
	manufactureProtocol LONGBLOB,
	channelCount VARCHAR(255),
	instrumentModel VARCHAR(255),
	machineCharacteristics VARCHAR(255),
	UNIQUE(organism, nickname, type)
);

DROP TABLE IF EXISTS koaladata;
CREATE TABLE koaladata (
	dataset BIGINT NOT NULL,
	tag VARCHAR(45) NOT NULL,
	value double default NULL,
	PRIMARY KEY (dataset, tag)
);
